#ifndef CLASS_ABS_PARSER_H
#define CLASS_ABS_PARSER_H

#include <kate/document.h>
#include "class.cppview.h"

#define GOTO_NEXT { i++; continue; }

#define GOTO_END    posStr = curStr.find("{");\
                                   posDef = curStr.find("}");\
                                   if(posStr != -1 || (posDef != -1)) {\
                                   if(posStr != -1 && (posDef == -1 || posStr < posDef) ) {\
                                        for(posDef = 0;posDef<curStr.length(); posDef++) {\
                                            if(curStr.at(posDef) == '{') { blockR++, shiftStr(posDef+1); break; }\
                                        }\
                                        continue;\
                                   }else if( posDef != -1 ) {\
                                        for(posDef = 0;posDef<curStr.length(); posDef++) {\
                                            if(curStr.at(posDef) == '}') { blockR--, shiftStr(posDef+1); break; }\
                                        }\
                                        if(blockR == 0) {\
                                            if(imIN == Struct) {\
                                            if((posStr = curStr.find(";")) != -1) {\
                                                name.append(QString(" "));\
                                                name.append(curStr.left(posStr));\
                                                shiftStr(posStr+1);\
                                            }\
                                            if(lastCommentStrNum+1 ==  defDeclaration) {\
                                                         DoxyObj *dxy = new DoxyObj(name, DoxyComment);\
                                                         dxy->type = CppView::Struct;\
                                                         doxyStack.push(dxy);\
                                            }\
                                            addStruct(name, defDeclaration);\
                                            }\
                                            imIN = Empty;\
                                            inTag = 0;\
                                         }\
                                         continue;\
                                   }\
                                }


class QString;

/*!
 * @class AbsParser
 * @brief Description
 * Abstract class for parsers
 * @author Andrei Dmitriev <andrei_dm@mail.ru>
 */
class AbsParser
{
    protected:
        void addFunc(QString &name, int strNum)  { addObject(name, strNum, CppView::Func ); }
        void addStruct(QString &name, int strNum);
        void addClass(QString &name, int strNum);
        void addMacros(QString &name, int strNum) { addObject(name, strNum, CppView::Macro); }
        void addObject(QString &name, int strNum, CppView::DefType type);
    private:

    public:
        AbsParser(){}
        virtual void parse(Kate::Document *doc)=0;
        virtual QString createDoc(const QString &name, CppView::DefType type) =0;
};

class ParseUtils
{
    protected:
        QString curStr;
        void shiftStr(uint strPos);
};

class CppParser : public AbsParser, public ParseUtils
{
        QString findFnName(Kate::Document *doc, QString name, int pos);
    public:
        CppParser() {}
        void parse(Kate::Document *doc);
        QString createDoc(const QString &name, CppView::DefType type);
};

class PerlParser : public AbsParser, public ParseUtils
{
        public:
        PerlParser();
        virtual void addFunc(QString &name, int strNum);
        void parse(Kate::Document *doc);
        QString createDoc(const QString &name, CppView::DefType type) { return QString(""); }
};

class JavaScriptParser : public AbsParser, public ParseUtils
{
        public:
        JavaScriptParser() {}
        //virtual void addFunc(QString &name, int strNum);
        void parse(Kate::Document *doc);
        QString createDoc(const QString &name, CppView::DefType type) { return QString(""); };
};

#endif // CLASS_ABS_PARSER_H