#include <qstring.h>
#include <qmap.h>
#include "class.cppview.h"
#include "class.cppviewitem.h"
#include "class.objectmap.h"

ItemObject::ItemObject(CppView::DefType type, QString &itName) 
                      : strNum(0), doxygen(0) {
        CppView *view = CppView::Instance();
        QListViewItem *item = view->getItem( type );
        viewItem = new CppViewItemBase(item, itName, type);
        view->FreeInst();
}

ItemObject::ItemObject(CppView::DefType type, QString &itName, QString &showName, ItemObject *parent)
                        : strNum(0), doxygen(0) {
        CppView *view = CppView::Instance();
        QListViewItem *item = parent->viewItem;
        viewItem = new CppViewItemBase(item, itName, showName,  type);
        view->FreeInst();               
}

ItemObject::~ItemObject() {
                if(doxygen) delete doxygen;              
}

ObjectMap::ObjectMap()
{
    items[CppView::Func] = new ItemMap();
    items[CppView::Struct] = new ItemMap();
    items[CppView::Class] = new ItemMap();
    items[CppView::Macro] = new ItemMap();
}

ObjectMap::~ObjectMap()
{
    ItemsMap::Iterator it;
    for ( it = items.begin(); it != items.end(); ++it ) {
               ItemMap::Iterator itAtr;
               ItemMap *curItemMap = it.data();
                if(!curItemMap) continue;
                for (itAtr = curItemMap->begin(); itAtr != curItemMap->end(); ++itAtr)
                {
                        if(itAtr.data()) delete itAtr.data();
                }
                delete curItemMap;
    } 
}

ItemObject* ObjectMap::addObject(QString &name,  CppView::DefType type)
{
    ItemMap *curLif = items[type];
    if(curLif->find(name) == curLif->end())    
                (*curLif)[name] = new ItemObject(type, name);
    return (*curLif)[name];
}
ItemObject* ObjectMap::addObject(QString &name,  QString &showName, CppView::DefType type, ItemObject *parent)
{
    ItemMap *curLif = items[type];
    if(curLif->find(name) == curLif->end())    
                (*curLif)[name] = new ItemObject(type, name, showName, parent);
    return (*curLif)[name];
}

ItemObject* ObjectMap::findObject(QString &name,  CppView::DefType type)
{
    ItemMap *curLif = items[type];
    if(curLif->find(name) != curLif->end()) {
                  return (*curLif)[name];
    }
    return NULL;
}

ItemObject* ObjectMap::wordInObject(const QString &name,  CppView::DefType type)
{
    ItemMap *curLif = items[type];
    ItemMap::Iterator it;
    for(it = curLif->begin(); it != curLif->end(); ++it ) {
                    if(it.key().find(name) != -1)
                    return (*curLif)[it.key()];
        }
        return NULL;
}
