#ifndef _SINGLETON_H_
#define _SINGLETON_H_
/*!
 * @class Singleton
 * @brief   
 */

class QWidget;

template <class T>
class Singleton
{
  static T* _self;
  static int _refcount;
protected:
  Singleton(){}
  virtual ~Singleton(){_self=NULL;}  
public:
  static T* QInstance(QWidget *parent = 0);
  static T* Instance();
  void FreeInst();

};

template <class T>
T*  Singleton<T>::_self = NULL;

template <class T>
int  Singleton<T>::_refcount=0;

template <class T>
T*  Singleton<T>::QInstance(QWidget *parent)
{
  if(!_self)
  if(parent)
    _self=new T(parent);
  else 
    _self=new T;
   _refcount++;
  return _self;
}

template <class T>
T*  Singleton<T>::Instance()
{
  if(!_self)
   _self=new T;
   _refcount++;
  return _self;
}

template <class T>
void  Singleton<T>::FreeInst()
{
  if(--_refcount==0)
    delete this;
}

#endif
